en = require('lingo').en

module.exports = 
  add: (actions, mongooseModel) ->
    modelNameToString        = mongooseModel.modelName.toLowerCase()
    modelNameToPluralString  = en.pluralize modelNameToString

    actions.get = (conditions={}, cb) =>
      mongooseModel.find conditions, (errors, documents) -> 
        response = {}
        if !errors
          response.status = 'success'
          response[modelNameToPluralString] = documents
        else
          response.status = 'failure'
          response.errors = errors
        cb response

    actions.getById = (id, cb) =>
      # TODO - handle errors being returned from the find
      mongooseModel.findById id, (errors, documents) ->
        response = {}
        if documents? 
          response.status       = 'success'
          response[modelNameToString]  = documents
        else 
          response.status       = 'failure'
          response.errors       = "#{modelNameToString} with id: #{id} not found"
        cb response

    actions.create = (data, cb) =>
      new mongooseModel(data).save (errors, document) ->
        response = {}
        if !errors
          response.status      = 'success'
          response[modelNameToString] = document
        else 
          response.status      = 'failure'
          response.errors      = errors 
        cb response

    # TODO - MongoDB update is a fire and forget operation, find and modify is the 'update' equivalent Rubyists will be familiar with
    # TODO - figure out how to handle this
    #
    actions.update = (data, cb) =>
      conditions = data.conditions or {}
      update     = data.update or {}
      options    = data.options or {}
      mongooseModel.update conditions, update, options, -> 
        cb status: 'success'

    # TODO - should this be called 'delete', would 'remove' be a better name
    actions.remove = (id, cb) =>
      # TODO - redo this, it is completely wrong
      mongooseModel.remove {'_id':id}, ->
        cb status: 'success'
