SocketStream Resource
===

A library to simplify adding CRUD to your SocketStream applications. Currently supports MongoDB through Mongoose.

Install
---

    npm install socketstream-resource

Usage
---

Say you've got a config/db.coffee file that looks like this:

``` coffeescript
global.mongoose = require 'mongoose'
mongoose.connect "mongodb://localhost/socketstream_resource_test"
global.Schema   = mongoose.Schema
global.ObjectId = Schema.ObjectId
global.Products = new Schema 
  name: String
global.Product = mongoose.model 'Product', Products
```

And you would like a way to create a server-side module that provides basic CRUD on top of this Mongoose Model. You have a file like app/server/products.coffee, that looks like this:

``` coffeescript
exports.actions =
  init = ->
    # Put your code here
```
Change the file so that it looks like this:

``` coffeescript
resource = require 'socketstream-resource'

exports.actions =
  init = ->
    # Put your code here

resource.add actions, Product
```

If you now boot your Socketstream console, and type SS.server.product, you should see the following output:

